//
//  CustomerBank.swift
//  RaveMobile
//
//  Created by Segun Solaja on 5/28/17.
//  Copyright © 2017 Segun Solaja. All rights reserved.
//

import UIKit

struct Bank: Codable {
    var bankCode:String?
    var isInternetBanking:Bool?
    var name:String?
    init(from decoder: Decoder) throws {
        let values = try decoder.container(keyedBy: CodingKeys.self)
        bankCode = try values.decodeIfPresent(String?.self, forKey: .bankCode) ?? nil
        isInternetBanking = try values.decodeIfPresent(Bool?.self, forKey: .isInternetBanking) ?? nil
        name = try values.decodeIfPresent(String?.self, forKey: .name) ?? nil
    }
}

extension Bank{
    enum CodingKeys:String,CodingKey{
        case name = "bankname"
        case isInternetBanking = "internetbanking"
        case bankCode = "bankcode"
    }
}

class BankTransferDetail {
    let flw_reference: String?
    let accountnumber: String?
    let bankname: String?
    let created_on: String?
    let expiry_date: String?
    let note: String?
    let amount: Double?
    
    var beneficiary: String {
        if let name = RaveConfig.sharedConfig().merchantName {
            return name
        }
        return "Bundle Wallet Technology Ltd"
    }
    
    init(json: [String: Any]) {
        print(json)
        flw_reference = json["flw_reference"] as? String
        accountnumber = json["accountnumber"] as? String
        bankname = json["bankname"] as? String
        created_on = json["created_on"] as? String
        expiry_date = json["expiry_date"] as? String
        note = json["note"] as? String
        amount = json["amount"] as? Double
    }
}
