//
//  ProgressHud.swift
//  Alamofire
//
//  Created by Johnson Ejezie on 11/09/2020.
//

import UIKit

class ProgressHUD: UIVisualEffectView {

    let activityIndictor: UIActivityIndicatorView = UIActivityIndicatorView(style: UIActivityIndicatorView.Style.whiteLarge)
    let blurEffect = UIBlurEffect(style: .dark)
    let vibrancyView: UIVisualEffectView

    init() {
        self.vibrancyView = UIVisualEffectView(effect: UIVibrancyEffect(blurEffect: blurEffect))
        super.init(effect: blurEffect)
        self.setup()
    }

    required init(coder aDecoder: NSCoder) {
        self.vibrancyView = UIVisualEffectView(effect: UIVibrancyEffect(blurEffect: blurEffect))
        super.init(coder: aDecoder)!
        self.setup()

    }

    func setup() {
        contentView.addSubview(vibrancyView)
        vibrancyView.contentView.addSubview(activityIndictor)
        activityIndictor.startAnimating()
    }

    override func didMoveToSuperview() {
        super.didMoveToSuperview()
        if let superview = self.superview {
            self.frame = superview.frame
            vibrancyView.frame = UIScreen.main.bounds
            activityIndictor.frame = CGRect(x: 0, y: 0, width: 80, height: 80)
            activityIndictor.center = CGPoint(x: UIScreen.main.bounds.width*0.5, y: UIScreen.main.bounds.height*0.5)
        }
    }

    func show() {
        self.isHidden = false
        if let superview = self.superview {
            superview.bringSubviewToFront(self)
        }
    }

    func hide() {
        self.isHidden = true
    }
}
